/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

int incr(int x);

/*@ ensures \result == incr(\old(i)); */
int __gen_e_acsl_f(int i);

int f(int i)
{
  int j = i + 1;
  return j;
}

int incr(int x)
{
  int __retres;
  __retres = x + 1;
  return __retres;
}

int main(void)
{
  int __retres;
  __e_acsl_memory_init((int *)0,(char ***)0,(size_t)8);
  int i = __gen_e_acsl_f(2);
  __retres = 0;
  __e_acsl_memory_clean();
  return __retres;
}

/*@ ensures \result == incr(\old(i)); */
int __gen_e_acsl_f(int i)
{
  int __gen_e_acsl_at;
  int __retres;
  __gen_e_acsl_at = i;
  __retres = f(i);
  {
    int __gen_e_acsl_incr_app;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\result",0,
                                 __retres);
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\old(i)",0,
                                 __gen_e_acsl_at);
    __gen_e_acsl_incr_app = incr(__gen_e_acsl_at);
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"incr(\\old(i))",
                                 0,__gen_e_acsl_incr_app);
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Postcondition";
    __gen_e_acsl_assert_data.pred_txt = "\\result == incr(\\old(i))";
    __gen_e_acsl_assert_data.file = "tests/special/builtin.i";
    __gen_e_acsl_assert_data.fct = "f";
    __gen_e_acsl_assert_data.line = 11;
    __e_acsl_assert(__retres == __gen_e_acsl_incr_app,
                    & __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
    return __retres;
  }
}


